<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ombs-OnlineMovieBookingSystem: src/httpserver/http_server.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ombs-OnlineMovieBookingSystem
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_d37b2b018bbc221799a85e44b06817cf.html">httpserver</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">http_server.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="http__server_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;SimpleJSON/json.hpp&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;multiplexer.hpp&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceomsb.html">omsb</a></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;{</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  <span class="comment">// Served parmeters</span></div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a47db1e9f6209ead9120a7ea360f2618d">   21</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a47db1e9f6209ead9120a7ea360f2618d">ombsIpAddress</a>[] = <span class="stringliteral">&quot;0.0.0.0&quot;</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a2085949a646e0fdd4d3dd07728d000a7">   22</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a2085949a646e0fdd4d3dd07728d000a7">ombsPort</a>[] = <span class="stringliteral">&quot;5000&quot;</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a604c29051b181fefaec2a3ca73bcf25f">   23</a></span>&#160;  constexpr <span class="keywordtype">int</span> <a class="code" href="namespaceomsb.html#a604c29051b181fefaec2a3ca73bcf25f">ombsThreads</a> = 100;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="comment">// Server Admin API</span></div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="namespaceomsb.html#adaa081f71b2c4b93586590ae1741add7">   26</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#adaa081f71b2c4b93586590ae1741add7">ombsAddTheaterEndpoint</a>[] = <span class="stringliteral">&quot;/addtheater&quot;</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a92aa63f88b439e55b947e15d93df764b">   27</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a92aa63f88b439e55b947e15d93df764b">ombsAddMovieEndpoint</a>[] = <span class="stringliteral">&quot;/addmovie&quot;</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a7985df2da8d951f070ec3649b8293f16">   28</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a7985df2da8d951f070ec3649b8293f16">ombsGetAllTheatersEndpoint</a>[] = <span class="stringliteral">&quot;/getalltheaters&quot;</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a455eaf86a103872b05c6fa1f13db7348">   29</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a455eaf86a103872b05c6fa1f13db7348">ombsGetAllMoviesEndpoint</a>[] = <span class="stringliteral">&quot;/getallmovies&quot;</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="namespaceomsb.html#ab5ea7f1ccefc59887b556d8aa43c494f">   30</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ab5ea7f1ccefc59887b556d8aa43c494f">ombsAddMovieShowEndpoint</a>[] = <span class="stringliteral">&quot;/addshow&quot;</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="namespaceomsb.html#af4f5e13978bab25d6d0f042a3e694a9b">   31</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#af4f5e13978bab25d6d0f042a3e694a9b">ombsBookSeatsEndpoint</a>[] = <span class="stringliteral">&quot;/bookseats&quot;</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;  <span class="comment">// Server user API</span></div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="namespaceomsb.html#af8d32bcae1ecbfd2d9a4aa72c0fd6c34">   34</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#af8d32bcae1ecbfd2d9a4aa72c0fd6c34">ombsGetAllMovieShowsEndpoint</a>[] = <span class="stringliteral">&quot;/&quot;</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a20941250a216ab77289cceb6ba61cdcb">   35</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a20941250a216ab77289cceb6ba61cdcb">ombsGetTheaterByMovieEndpoint</a>[] = <span class="stringliteral">&quot;/{movie_id}&quot;</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="namespaceomsb.html#ad871d082de14f4a98ff3653f3bb9231a">   36</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ad871d082de14f4a98ff3653f3bb9231a">ombsGetAvailableSeatsByMovieAndByTheaterEndpoint</a>[] = <span class="stringliteral">&quot;/{movie_id}/{theater_id}&quot;</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="comment">// TODO robustness: Can handle all false returns by exception thrpown by MogoDbHandler to distanguiche which error is made.</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="comment">// TODO robustness: check of all received post requests  bodies that well formed else return 400 (malformed request)</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="comment">// TODO robustness: do a test if mongoDB server is shutdown!!!!!!</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classomsb_1_1_http_server.html">   53</a></span>&#160;  <span class="keyword">class </span><a class="code" href="classomsb_1_1_http_server.html">HttpServer</a></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  {</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <a class="code" href="classomsb_1_1_http_server.html#a869340b7e360c5966313d9d560eadf7f">HttpServer</a>(served::multiplexer multiplexer);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classomsb_1_1_http_server.html#a790f33952f28a1045959d77f59550133">StartServer</a>();</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="keyword">private</span>:</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    served::multiplexer multiplexer;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">void</span> InitializeEndpoints();</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">auto</span> AddTheaterToMongoDb();</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keyword">auto</span> AddMovieToMongoDb();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">auto</span> AddMovieShowToMongoDb();</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keyword">auto</span> GetAllTheaters();</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keyword">auto</span> GetAllMovies();</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keyword">auto</span> GetAllMovieShows();</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="keyword">auto</span> GetTheatersByMovie();</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="keyword">auto</span> GetAvailableSeatsByMovieAndByTheater();</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160; </div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keyword">auto</span> BookSeats();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <span class="keywordtype">bool</span> BookSeatsRequestBodyValidation(<span class="keyword">const</span> json::JSON &amp;request_body_json);</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;  }; <span class="comment">// Class</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;} <span class="comment">// namespace omsb</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespaceomsb_html_ad871d082de14f4a98ff3653f3bb9231a"><div class="ttname"><a href="namespaceomsb.html#ad871d082de14f4a98ff3653f3bb9231a">omsb::ombsGetAvailableSeatsByMovieAndByTheaterEndpoint</a></div><div class="ttdeci">constexpr char ombsGetAvailableSeatsByMovieAndByTheaterEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:36</div></div>
<div class="ttc" id="anamespaceomsb_html_af8d32bcae1ecbfd2d9a4aa72c0fd6c34"><div class="ttname"><a href="namespaceomsb.html#af8d32bcae1ecbfd2d9a4aa72c0fd6c34">omsb::ombsGetAllMovieShowsEndpoint</a></div><div class="ttdeci">constexpr char ombsGetAllMovieShowsEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:34</div></div>
<div class="ttc" id="anamespaceomsb_html_a7985df2da8d951f070ec3649b8293f16"><div class="ttname"><a href="namespaceomsb.html#a7985df2da8d951f070ec3649b8293f16">omsb::ombsGetAllTheatersEndpoint</a></div><div class="ttdeci">constexpr char ombsGetAllTheatersEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:28</div></div>
<div class="ttc" id="anamespaceomsb_html_ab5ea7f1ccefc59887b556d8aa43c494f"><div class="ttname"><a href="namespaceomsb.html#ab5ea7f1ccefc59887b556d8aa43c494f">omsb::ombsAddMovieShowEndpoint</a></div><div class="ttdeci">constexpr char ombsAddMovieShowEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:30</div></div>
<div class="ttc" id="anamespaceomsb_html_af4f5e13978bab25d6d0f042a3e694a9b"><div class="ttname"><a href="namespaceomsb.html#af4f5e13978bab25d6d0f042a3e694a9b">omsb::ombsBookSeatsEndpoint</a></div><div class="ttdeci">constexpr char ombsBookSeatsEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:31</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_ae76b951defd231273ee70264e82ca6d0"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#ae76b951defd231273ee70264e82ca6d0">omsb::MongoDbHandler::AddMovieToDb</a></div><div class="ttdeci">bool AddMovieToDb(const std::string &amp;movie_title)</div><div class="ttdoc">creates a new movie in ombs database.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:18</div></div>
<div class="ttc" id="anamespaceomsb_html_a2085949a646e0fdd4d3dd07728d000a7"><div class="ttname"><a href="namespaceomsb.html#a2085949a646e0fdd4d3dd07728d000a7">omsb::ombsPort</a></div><div class="ttdeci">constexpr char ombsPort[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:22</div></div>
<div class="ttc" id="anamespaceomsb_html_adaa081f71b2c4b93586590ae1741add7"><div class="ttname"><a href="namespaceomsb.html#adaa081f71b2c4b93586590ae1741add7">omsb::ombsAddTheaterEndpoint</a></div><div class="ttdeci">constexpr char ombsAddTheaterEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:26</div></div>
<div class="ttc" id="anamespaceomsb_html"><div class="ttname"><a href="namespaceomsb.html">omsb</a></div><div class="ttdef"><b>Definition:</b> http_server.cpp:7</div></div>
<div class="ttc" id="ahttp__server_8hpp_html"><div class="ttname"><a href="http__server_8hpp.html">http_server.hpp</a></div></div>
<div class="ttc" id="anamespaceomsb_html_a47db1e9f6209ead9120a7ea360f2618d"><div class="ttname"><a href="namespaceomsb.html#a47db1e9f6209ead9120a7ea360f2618d">omsb::ombsIpAddress</a></div><div class="ttdeci">constexpr char ombsIpAddress[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:21</div></div>
<div class="ttc" id="amain_8cpp_html_ae66f6b31b5ad750f1fe042a706a4e3d4"><div class="ttname"><a href="main_8cpp.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a></div><div class="ttdeci">int main()</div><div class="ttdoc">this is the server main application it just creating then starting ombs server</div><div class="ttdef"><b>Definition:</b> main.cpp:10</div></div>
<div class="ttc" id="aclassomsb_1_1_http_server_html_a869340b7e360c5966313d9d560eadf7f"><div class="ttname"><a href="classomsb_1_1_http_server.html#a869340b7e360c5966313d9d560eadf7f">omsb::HttpServer::HttpServer</a></div><div class="ttdeci">HttpServer(served::multiplexer multiplexer)</div><div class="ttdoc">Construct a new Http Server object.</div><div class="ttdef"><b>Definition:</b> http_server.cpp:11</div></div>
<div class="ttc" id="ahttpserver_2_c_make_lists_8txt_html_ac2cfeab11688d05f7efa525d86ee1c97"><div class="ttname"><a href="httpserver_2_c_make_lists_8txt.html#ac2cfeab11688d05f7efa525d86ee1c97">add_library</a></div><div class="ttdeci">add_library(httpserver &quot;&quot;) target_sources(httpserver PRIVATE http_server.cpp PUBLIC $</div><div class="ttdef"><b>Definition:</b> CMakeLists.txt:1</div></div>
<div class="ttc" id="anamespaceomsb_html_a455eaf86a103872b05c6fa1f13db7348"><div class="ttname"><a href="namespaceomsb.html#a455eaf86a103872b05c6fa1f13db7348">omsb::ombsGetAllMoviesEndpoint</a></div><div class="ttdeci">constexpr char ombsGetAllMoviesEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:29</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html">omsb::MongoDbHandler</a></div><div class="ttdoc">this is the class to allow creation of controller objects as needed for ombs mongodb database</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:63</div></div>
<div class="ttc" id="aclassomsb_1_1_http_server_html"><div class="ttname"><a href="classomsb_1_1_http_server.html">omsb::HttpServer</a></div><div class="ttdoc">this the class that handels user REST API requests. we only need to create one object abd start serve...</div><div class="ttdef"><b>Definition:</b> http_server.hpp:53</div></div>
<div class="ttc" id="anamespaceomsb_html_a604c29051b181fefaec2a3ca73bcf25f"><div class="ttname"><a href="namespaceomsb.html#a604c29051b181fefaec2a3ca73bcf25f">omsb::ombsThreads</a></div><div class="ttdeci">constexpr int ombsThreads</div><div class="ttdef"><b>Definition:</b> http_server.hpp:23</div></div>
<div class="ttc" id="aclassomsb_1_1_http_server_html_a790f33952f28a1045959d77f59550133"><div class="ttname"><a href="classomsb_1_1_http_server.html#a790f33952f28a1045959d77f59550133">omsb::HttpServer::StartServer</a></div><div class="ttdeci">void StartServer()</div><div class="ttdoc">Starts the server after endpoints have been initialized.</div><div class="ttdef"><b>Definition:</b> http_server.cpp:17</div></div>
<div class="ttc" id="amongodb__handler_8hpp_html"><div class="ttname"><a href="mongodb__handler_8hpp.html">mongodb_handler.hpp</a></div></div>
<div class="ttc" id="anamespaceomsb_html_a92aa63f88b439e55b947e15d93df764b"><div class="ttname"><a href="namespaceomsb.html#a92aa63f88b439e55b947e15d93df764b">omsb::ombsAddMovieEndpoint</a></div><div class="ttdeci">constexpr char ombsAddMovieEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:27</div></div>
<div class="ttc" id="anamespaceomsb_html_a20941250a216ab77289cceb6ba61cdcb"><div class="ttname"><a href="namespaceomsb.html#a20941250a216ab77289cceb6ba61cdcb">omsb::ombsGetTheaterByMovieEndpoint</a></div><div class="ttdeci">constexpr char ombsGetTheaterByMovieEndpoint[]</div><div class="ttdef"><b>Definition:</b> http_server.hpp:35</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
